=== debian/changelog ===
captive (1.1.7) unstable; urgency=low
  * See package ChangeLog entries.
 -- Jan Kratochvil <pgp-44FC7632@jankratochvil.net>  Sun, 17 Aug 2003 14:16:59 +0200
