=== debian/control ===
Source: captive
Section: contrib/base
Priority: optional
Maintainer: Jan Kratochvil <project-captive@jankratochvil.net>
Build-Depends: debhelper (>> 3.0.0),
 liborbit2-dev,
 libssl-dev,
 libgnomevfs2-dev,
 libxml2-dev (>= 2.4.29),
 libpopt-dev,
 libglib2.0-dev,
 libreadline4-dev,
 libbonobo2-dev,
 lufs,
 ntfsprogs-dev,
 libgnomeui-dev,
 gcc (>= 3.0) | gcc-3.0,
Standards-Version: 3.5.2

Package: captive
Architecture: i386
Depends: liborbit2,
 libssl0.9.7,
 libgnomevfs2-0,
 libxml2,
 libpopt0,
 libglib2.0-0,
 libreadline4
# Due to --with-orbit-line=link
Conflicts: liborbit2 (<< 2.8.2)
Recommends: captive-lufs (= ${Source-Version})
Description: NTFS filesystem using Microsoft Windows drivers
 Existing binary Microsoft Windows file system drivers were exploited
 for accessing drives with possibly proprietary file system data structures.
 Open file system API is provided to access these file system drivers.
 Microsoft Windows system components required by these drivers
 were analyzed and successfuly emulated in the GNU/Linux operating system.
 .
 The implementation allows applications running under the GNU/Linux operating
 system to access NTFS drives. File system driver compatibility with VFAT,
 ISO9660 and EXT2 is also provided.

Package: captive-lufs
Architecture: i386
Depends: captive (= ${Source-Version}),
 lufs,
 libpopt0
Description: LUFS module for Microsoft Windows platform filesystem access.
 LUFS is a hybrid userspace filesystem framework.
 .
 Package provides LUFS filesystem module to access Microsoft Windows platform
 filesystems such as NTFS. Use filesystem type 'captive-ntfs' for NTFS disks.

Package: captive-install
Architecture: i386
Depends: captive-lufs (= ${Source-Version}),
 ntfsprogs,
 libreadline4,
 libgnomeui-0,
 libpopt0,
 ntfsprogs-gnomevfs,
 gnome-vfs-httpcaptive,
 libxml2 (>= 2.4.29)
Description: Instant installer for Microsoft Windows platform filesystem access.
 Package provides easy enough unattended installation of Microsoft Windows
 platform filesystem access. Installer finds available NTFS partitions and
 tries to acquire needed Microsoft Windows filesystem driver files.
